/** przyklad wyscigu i uzycia blokady */

#include <boost/thread/mutex.hpp>
#include <boost/thread/thread.hpp>
#include <iostream>

int counter;
boost::mutex mutex;

void thread_fun() {
	for(int i=0;i<9000000;++i) {
		boost::mutex::scoped_lock scoped_lock(mutex);
		++counter;
	}
}

int main() {
    const int NUM = 4;
    boost::thread_group thrds;
    for (int i=0; i < NUM; ++i)
        thrds.create_thread(&thread_fun);
    thrds.join_all();
	std::cout << "counter: " << counter << std::endl;
    return 0;
}



